----------------------------------------
--  INFORMATION                       --
----------------------------------------
-- Advanced Bot Team Balance v1.4
-- Created by Rich Weeds Nagel (USGN: 110755) - January 2, 2013
-- http://www.unrealsoftware.de/profile.php?userid=110755
-- richnagel@centurylink.net
-- http://www.richnagel.net
--
-- This Lua script for Counter-Strike 2D will automatically add or remove bots
-- to a server in order to maintain a specified number of total players (bots
-- plus humans) within the game.
--
-- Refer to the included "AdvancedBotTeamBalance.txt" readme file for complete
-- installation and usage instructions.


----------------------------------------
--  RUNTIME DEFAULTS                  --
----------------------------------------
pcall(dofile,"Sys/AdvancedBotTeamBalance.cfg")

if (bot_balance_enabled == 1) then
	addhook('ms100','advanced_bot_team_balance_functions')
end


----------------------------------------
--  INITIAL SETUP DEFAULTS            --
----------------------------------------
if bot_balance == nil or bot_balance_enabled == nil then
	bot_balance = 5
	bot_balance_enabled = 1
	addhook('ms100','advanced_bot_team_balance_functions')
	local AdvancedBotTeamBalanceConfig=io.open("Sys/AdvancedBotTeamBalance.cfg","w")
	AdvancedBotTeamBalanceConfig:write("bot_balance = 5".."\n")
	AdvancedBotTeamBalanceConfig:write("bot_balance_enabled = 1".."\n")
	AdvancedBotTeamBalanceConfig:close()
end


----------------------------------------
--  JOIN SERVER WELCOME MESSAGE       --
----------------------------------------
addhook('join','advanced_bot_team_balance_join_server_message')
function advanced_bot_team_balance_join_server_message(player_id)

	if (bot_balance_enabled == 1) then
		msg2(player_id,"000255000This server is running Advanced Bot Team Balance v1.4!@C")
		msg2(player_id,"000255000Created by Rich Weeds Nagel (USGN: 110755) - January 2, 2013@C")
		msg2(player_id,"000255000Bot Team Balance is currently enabled, and is set to "..bot_balance.." player(s) per team.@C")
	else
		msg2(player_id,"000255000This server is running Advanced Bot Team Balance v1.4!@C")
		msg2(player_id,"000255000Created by Rich Weeds Nagel (USGN: 110755) - January 2, 2013@C")
		msg2(player_id,"000255000Bot Team Balance is currently disabled.@C")
	end

end


----------------------------------------
--  CONSOLE COMMANDS                  --
----------------------------------------
addhook('parse','advanced_bot_team_balance_console_commands')
function advanced_bot_team_balance_console_commands(cmd)

	if (cmd=='bot_balance 0') then
		bot_balance = 0
		bot_balance_enabled = 1
		addhook('ms100','advanced_bot_team_balance_functions')
		msg("000255000Bot Team Balance is currently enabled, and has been changed to 0 player(s) per team.@C")
		local AdvancedBotTeamBalanceConfig=io.open("Sys/AdvancedBotTeamBalance.cfg","w")
		AdvancedBotTeamBalanceConfig:write("bot_balance = "..bot_balance.."\n")
		AdvancedBotTeamBalanceConfig:write("bot_balance_enabled = 1".."\n")
		AdvancedBotTeamBalanceConfig:close()
		return 1
	end

	if (cmd=='bot_balance 1') then
		bot_balance = 1
		bot_balance_enabled = 1
		addhook('ms100','advanced_bot_team_balance_functions')
		msg("000255000Bot Team Balance is currently enabled, and has been changed to 1 player(s) per team.@C")
		local AdvancedBotTeamBalanceConfig=io.open("Sys/AdvancedBotTeamBalance.cfg","w")
		AdvancedBotTeamBalanceConfig:write("bot_balance = "..bot_balance.."\n")
		AdvancedBotTeamBalanceConfig:write("bot_balance_enabled = 1".."\n")
		AdvancedBotTeamBalanceConfig:close()
		return 1
	end

	if (cmd=='bot_balance 2') then
		bot_balance = 2
		bot_balance_enabled = 1
		addhook('ms100','advanced_bot_team_balance_functions')
		msg("000255000Bot Team Balance is currently enabled, and has been changed to 2 player(s) per team.@C")
		local AdvancedBotTeamBalanceConfig=io.open("Sys/AdvancedBotTeamBalance.cfg","w")
		AdvancedBotTeamBalanceConfig:write("bot_balance = "..bot_balance.."\n")
		AdvancedBotTeamBalanceConfig:write("bot_balance_enabled = 1".."\n")
		AdvancedBotTeamBalanceConfig:close()
		return 1
	end

	if (cmd=='bot_balance 3') then
		bot_balance = 3
		bot_balance_enabled = 1
		addhook('ms100','advanced_bot_team_balance_functions')
		msg("000255000Bot Team Balance is currently enabled, and has been changed to 3 player(s) per team.@C")
		local AdvancedBotTeamBalanceConfig=io.open("Sys/AdvancedBotTeamBalance.cfg","w")
		AdvancedBotTeamBalanceConfig:write("bot_balance = "..bot_balance.."\n")
		AdvancedBotTeamBalanceConfig:write("bot_balance_enabled = 1".."\n")
		AdvancedBotTeamBalanceConfig:close()
		return 1
	end

	if (cmd=='bot_balance 4') then
		bot_balance = 4
		bot_balance_enabled = 1
		addhook('ms100','advanced_bot_team_balance_functions')
		msg("000255000Bot Team Balance is currently enabled, and has been changed to 4 player(s) per team.@C")
		local AdvancedBotTeamBalanceConfig=io.open("Sys/AdvancedBotTeamBalance.cfg","w")
		AdvancedBotTeamBalanceConfig:write("bot_balance = "..bot_balance.."\n")
		AdvancedBotTeamBalanceConfig:write("bot_balance_enabled = 1".."\n")
		AdvancedBotTeamBalanceConfig:close()
		return 1
	end

	if (cmd=='bot_balance 5') then
		bot_balance = 5
		bot_balance_enabled = 1
		addhook('ms100','advanced_bot_team_balance_functions')
		msg("000255000Bot Team Balance is currently enabled, and has been changed to 5 player(s) per team.@C")
		local AdvancedBotTeamBalanceConfig=io.open("Sys/AdvancedBotTeamBalance.cfg","w")
		AdvancedBotTeamBalanceConfig:write("bot_balance = "..bot_balance.."\n")
		AdvancedBotTeamBalanceConfig:write("bot_balance_enabled = 1".."\n")
		AdvancedBotTeamBalanceConfig:close()
		return 1
	end

	if (cmd=='bot_balance 6') then
		bot_balance = 6
		bot_balance_enabled = 1
		addhook('ms100','advanced_bot_team_balance_functions')
		msg("000255000Bot Team Balance is currently enabled, and has been changed to 6 player(s) per team.@C")
		local AdvancedBotTeamBalanceConfig=io.open("Sys/AdvancedBotTeamBalance.cfg","w")
		AdvancedBotTeamBalanceConfig:write("bot_balance = "..bot_balance.."\n")
		AdvancedBotTeamBalanceConfig:write("bot_balance_enabled = 1".."\n")
		AdvancedBotTeamBalanceConfig:close()
		return 1
	end

	if (cmd=='bot_balance 7') then
		bot_balance = 7
		bot_balance_enabled = 1
		addhook('ms100','advanced_bot_team_balance_functions')
		msg("000255000Bot Team Balance is currently enabled, and has been changed to 7 player(s) per team.@C")
		local AdvancedBotTeamBalanceConfig=io.open("Sys/AdvancedBotTeamBalance.cfg","w")
		AdvancedBotTeamBalanceConfig:write("bot_balance = "..bot_balance.."\n")
		AdvancedBotTeamBalanceConfig:write("bot_balance_enabled = 1".."\n")
		AdvancedBotTeamBalanceConfig:close()
		return 1
	end

	if (cmd=='bot_balance 8') then
		bot_balance = 8
		bot_balance_enabled = 1
		addhook('ms100','advanced_bot_team_balance_functions')
		msg("000255000Bot Team Balance is currently enabled, and has been changed to 8 player(s) per team.@C")
		local AdvancedBotTeamBalanceConfig=io.open("Sys/AdvancedBotTeamBalance.cfg","w")
		AdvancedBotTeamBalanceConfig:write("bot_balance = "..bot_balance.."\n")
		AdvancedBotTeamBalanceConfig:write("bot_balance_enabled = 1".."\n")
		AdvancedBotTeamBalanceConfig:close()
		return 1
	end

	if (cmd=='bot_balance 9') then
		bot_balance = 9
		bot_balance_enabled = 1
		addhook('ms100','advanced_bot_team_balance_functions')
		msg("000255000Bot Team Balance is currently enabled, and has been changed to 9 player(s) per team.@C")
		local AdvancedBotTeamBalanceConfig=io.open("Sys/AdvancedBotTeamBalance.cfg","w")
		AdvancedBotTeamBalanceConfig:write("bot_balance = "..bot_balance.."\n")
		AdvancedBotTeamBalanceConfig:write("bot_balance_enabled = 1".."\n")
		AdvancedBotTeamBalanceConfig:close()
		return 1
	end

	if (cmd=='bot_balance 10') then
		bot_balance = 10
		bot_balance_enabled = 1
		addhook('ms100','advanced_bot_team_balance_functions')
		msg("000255000Bot Team Balance is currently enabled, and has been changed to 10 player(s) per team.@C")
		local AdvancedBotTeamBalanceConfig=io.open("Sys/AdvancedBotTeamBalance.cfg","w")
		AdvancedBotTeamBalanceConfig:write("bot_balance = "..bot_balance.."\n")
		AdvancedBotTeamBalanceConfig:write("bot_balance_enabled = 1".."\n")
		AdvancedBotTeamBalanceConfig:close()
		return 1
	end

	if (cmd=='bot_balance 11') then
		bot_balance = 11
		bot_balance_enabled = 1
		addhook('ms100','advanced_bot_team_balance_functions')
		msg("000255000Bot Team Balance is currently enabled, and has been changed to 11 player(s) per team.@C")
		local AdvancedBotTeamBalanceConfig=io.open("Sys/AdvancedBotTeamBalance.cfg","w")
		AdvancedBotTeamBalanceConfig:write("bot_balance = "..bot_balance.."\n")
		AdvancedBotTeamBalanceConfig:write("bot_balance_enabled = 1".."\n")
		AdvancedBotTeamBalanceConfig:close()
		return 1
	end

	if (cmd=='bot_balance 12') then
		bot_balance = 12
		bot_balance_enabled = 1
		addhook('ms100','advanced_bot_team_balance_functions')
		msg("000255000Bot Team Balance is currently enabled, and has been changed to 12 player(s) per team.@C")
		local AdvancedBotTeamBalanceConfig=io.open("Sys/AdvancedBotTeamBalance.cfg","w")
		AdvancedBotTeamBalanceConfig:write("bot_balance = "..bot_balance.."\n")
		AdvancedBotTeamBalanceConfig:write("bot_balance_enabled = 1".."\n")
		AdvancedBotTeamBalanceConfig:close()
		return 1
	end

	if (cmd=='bot_balance 13') then
		bot_balance = 13
		bot_balance_enabled = 1
		addhook('ms100','advanced_bot_team_balance_functions')
		msg("000255000Bot Team Balance is currently enabled, and has been changed to 13 player(s) per team.@C")
		local AdvancedBotTeamBalanceConfig=io.open("Sys/AdvancedBotTeamBalance.cfg","w")
		AdvancedBotTeamBalanceConfig:write("bot_balance = "..bot_balance.."\n")
		AdvancedBotTeamBalanceConfig:write("bot_balance_enabled = 1".."\n")
		AdvancedBotTeamBalanceConfig:close()
		return 1
	end

	if (cmd=='bot_balance 14') then
		bot_balance = 14
		bot_balance_enabled = 1
		addhook('ms100','advanced_bot_team_balance_functions')
		msg("000255000Bot Team Balance is currently enabled, and has been changed to 14 player(s) per team.@C")
		local AdvancedBotTeamBalanceConfig=io.open("Sys/AdvancedBotTeamBalance.cfg","w")
		AdvancedBotTeamBalanceConfig:write("bot_balance = "..bot_balance.."\n")
		AdvancedBotTeamBalanceConfig:write("bot_balance_enabled = 1".."\n")
		AdvancedBotTeamBalanceConfig:close()
		return 1
	end

	if (cmd=='bot_balance 15') then
		bot_balance = 15
		bot_balance_enabled = 1
		addhook('ms100','advanced_bot_team_balance_functions')
		msg("000255000Bot Team Balance is currently enabled, and has been changed to 15 player(s) per team.@C")
		local AdvancedBotTeamBalanceConfig=io.open("Sys/AdvancedBotTeamBalance.cfg","w")
		AdvancedBotTeamBalanceConfig:write("bot_balance = "..bot_balance.."\n")
		AdvancedBotTeamBalanceConfig:write("bot_balance_enabled = 1".."\n")
		AdvancedBotTeamBalanceConfig:close()
		return 1
	end

	if (cmd=='bot_balance on') then
		bot_balance_enabled = 1
		addhook('ms100','advanced_bot_team_balance_functions')
		msg("000255000Bot Team Balance has been enabled, and is set to "..bot_balance.." player(s) per team.@C")
		local AdvancedBotTeamBalanceConfig=io.open("Sys/AdvancedBotTeamBalance.cfg","w")
		AdvancedBotTeamBalanceConfig:write("bot_balance = "..bot_balance.."\n")
		AdvancedBotTeamBalanceConfig:write("bot_balance_enabled = 1".."\n")
		AdvancedBotTeamBalanceConfig:close()
		return 1
	end

	if (cmd=='bot_balance off') then
		bot_balance_enabled = 0
		freehook('ms100','advanced_bot_team_balance_functions')
		msg("000255000Bot Team Balance has been disabled.@C")
		local AdvancedBotTeamBalanceConfig=io.open("Sys/AdvancedBotTeamBalance.cfg","w")
		AdvancedBotTeamBalanceConfig:write("bot_balance = "..bot_balance.."\n")
		AdvancedBotTeamBalanceConfig:write("bot_balance_enabled = 0".."\n")
		AdvancedBotTeamBalanceConfig:close()
		return 1
	end

	if (cmd=='bot_balance message') or (cmd=='bot_balance welcome') then
		if (bot_balance_enabled == 1) then
			msg("000255000This server is running Advanced Bot Team Balance v1.4!@C")
			msg("000255000Created by Rich Weeds Nagel (USGN: 110755) - January 2, 2013@C")
			msg("000255000Bot Team Balance is currently enabled, and is set to "..bot_balance.." player(s) per team.@C")
			return 1
		else
			msg("000255000This server is running Advanced Bot Team Balance v1.4!@C")
			msg("000255000Created by Rich Weeds Nagel (USGN: 110755) - January 2, 2013@C")
			msg("000255000Bot Team Balance is currently disabled.@C")
			return 1
		end
	end

	if (cmd=='bot_balance') or (cmd=='bot_balance ') or (cmd=='bot_balance ?') or (cmd=='bot_balance 16') or (cmd=='bot_balance help') then
		print("255255255----------------------------------------")
		print("255255255Advanced Bot Team Balance v1.4")
		print("000255000Created by Rich Weeds Nagel (USGN: 110755) - January 2, 2013")
		print("000255000richnagel@centurylink.net")
		print("000255000http://www.richnagel.net")
		print(" ")
		print("255255255Console Commands (Listen Server, or Dedicated Server via RCon):")
		print(" ")
		print("000255000bot_balance <players> = Enable Advanced Bot Team Balance, and change Bot Team Balance to 0-15 player(s) per team.")
		print(" ")
		print("000255000bot_balance on = Enable Advanced Bot Team Balance.")
		print("000255000bot_balance off = Disable Advanced Bot Team Balance.")
		print(" ")
		print("000255000bot_balance welcome/message = Display join server welcome message, and current Bot Team Balance settings to all players.")
		print(" ")
		print("000255000bot_balance help/? = Display help screen.")
		print("000255000bot_balance version/about = Display version information.")
		print("255255255----------------------------------------")
		return 1
	end

	if (cmd=='bot_balance about') or (cmd=='bot_balance version') then
		print("255255255----------------------------------------")
		print("255255255Advanced Bot Team Balance v1.4")
		print("000255000Created by Rich Weeds Nagel (USGN: 110755) - January 2, 2013")
		print("000255000richnagel@centurylink.net")
		print("000255000http://www.richnagel.net")
		print("255255255----------------------------------------")
		return 1
	end

end


----------------------------------------
--  BOT TEAM BALANCING FUNCTIONS      --
----------------------------------------
function advanced_bot_team_balance_functions()

	spectator_player_count = 0
	terrorist_player_count = 0
	counter_terrorist_player_count = 0

		for i = 1,32, 1 do
			if (player(i,'exists')) and (player(i,'team') == 0) then
				spectator_player_count = spectator_player_count + 1
			end
		end

		for i = 1,32, 1 do
			if (player(i,'exists')) and (player(i,'team') == 1) then
				terrorist_player_count = terrorist_player_count + 1
			end
		end
	
		for i = 1,32, 1 do
			if (player(i,'exists')) and (player(i,'team') == 2) then
				counter_terrorist_player_count = counter_terrorist_player_count + 1
			end
		end

		for i = 1,32, 1 do
			if (player(i,'exists')) and (player(i,'team') == 3) then
				counter_terrorist_player_count = counter_terrorist_player_count + 1
			end
		end

		if (terrorist_player_count < bot_balance) then
			parse('bot_add_t')
		end

		if (counter_terrorist_player_count < bot_balance) then
			parse('bot_add_ct')
		end
	
		if (terrorist_player_count > bot_balance) then
			parse('bot_remove_t')
		end

		if (counter_terrorist_player_count > bot_balance) then
			parse('bot_remove_ct')
		end

end


-- EOF --